#include <p24fj64ga002.h>
#include "pinmap.h"
#include "HardwareProfile.h"
//#include "UsartToMaster.h"

#define delay1mks asm("nop"); asm("nop"); asm("nop"); asm("nop")

void hard_init(void) {
/*	//   
   __asm__ ("MOV #OSCCONH,  w1");
   __asm__ ("MOV #0x78,  w2");
   __asm__ ("MOV #0x9A,  w3");
   __asm__ ("MOV.b w2, [w1]");
   __asm__ ("MOV.b w3, [w1]");
	OSCCONbits.COSC = 0;			// 000 = Fast RC Oscillator (FRC)
									// 001 = Fast RC Oscillator with Postscaler and PLL module (FRCPLL)
									// 010 = Primary Oscillator (XT, HS, EC)
									// 011 = Primary Oscillator with PLL module (XTPLL, HSPLL, ECPLL)
									// 100 = Secondary Oscillator (SOSC)
									// 101 = Low-Power RC Oscillator (LPRC)
									// 110 = Reserved
									// 111 = Fast RC Oscillator with Postscaler (FRCDIV)
*/
   // Turn on the secondary oscillator
   __asm__ ("MOV #OSCCON,w1");
   __asm__ ("MOV #0x46, w2");
   __asm__ ("MOV #0x57, w3");
   __asm__ ("MOV.b w2, [w1]");
   __asm__ ("MOV.b w3, [w1]");
    OSCCONbits.IOLOCK = 0;

//	init_rtcc();

	AD1CON1bits.ADON = 0;		// 0 = A/D Converter is off
	AD1PCFG = 0xFFFF;			//      

    // #########################################################################################################
	//							  -
    // #########################################################################################################

	PIN_LED_TRIS = 0;		//  
	PIN_LED_OUT = 0;

	
// ######################################################################################################
// #######################  SPI-1 Ethernet #####################################################
// ######################################################################################################
	// CS
	PIN_ENC_CS_TRIS = 0;
	PIN_ENC_CS_OUT = 1;
	// SCK1 (8)  RP1    
	PIN_ENC_SCK_TRIS = 0;
	PIN_ENC_SCK_RPO = 8;
	// SDO1 (7)  RP2    
	PIN_ENC_SI_TRIS = 0;
	PIN_ENC_SI_RPO = 7;
 	// SDI1  RP3    
	PIN_ENC_SO_TRIS = 1;
	RPINR20bits.SDI1R = PIN_ENC_SO_NUM;
	
	SPI1CON1bits.SPRE = 7;		// 0=8:1, 1=7:1, 2=6:1, 3=5:1, 4=4:1, 5=3:1, 6=2:1, 7=1:1
	SPI1CON1bits.PPRE = 2;		// 0=64:1, 1=16:1, 2=4:1, 3=1:1
	SPI1CON1bits.MSTEN = 1; 	// 1 = SPI-MASTER
	SPI1CON1bits.CKP = 0; 		// 1 = Idle state for clock is a high level; active state is a low level
								// 0 = Idle state for clock is a low level; active state is a high level
	SPI1CON1bits.CKE = 0; 		// 1 = Serial output data changes on transition from active clock state to Idle clock state
								// 0 = Serial output data changes on transition from Idle clock state to active clock state
	SPI1CON1bits.MODE16 = 0;	// 0 = Communication is byte-wide (8 bits)
								// 1 = Communication is word-wide (16 bits)
	SPI1STATbits.SPIEN = 1;		// 1 = Enables module and configures SCKx, SDOx, SDIx and SSx as serial port pins
								// 0 = Disables module
	SPI1STATbits.SPIROV = 0;	//   
									
	// ##################################################################################################
	// 				  MDD
	// ##################################################################################################
/*
	//	 SPI-2

	// SCK2 (11)  RPO    
	PIN_SD_CLK_TRIS = 0;
	PIN_SD_CLK_RPO = 11;
	// SDO2 (10)  RPO    
	PIN_SD_DI_TRIS = 0;
	PIN_SD_DI_RPO = 10;
 	// SDI2  RP3    
	PIN_SD_DO_TRIS = 1;
	RPINR22bits.SDI2R = PIN_SD_DO_NUM;
	
	SPI2CON1bits.SPRE = 7;		// 0=8:1, 1=7:1, 2=6:1, 3=5:1, 4=4:1, 5=3:1, 6=2:1, 7=1:1
	SPI2CON1bits.PPRE = 2;		// 0=64:1, 1=16:1, 2=4:1, 3=1:1
	SPI2CON1bits.MSTEN = 1; 	// 1 = SPI-MASTER
	SPI2CON1bits.CKP = 0; 		// 1 = Idle state for clock is a high level; active state is a low level
								// 0 = Idle state for clock is a low level; active state is a high level
	SPI2CON1bits.CKE = 1; 		// 1 = Serial output data changes on transition from active clock state to Idle clock state
								// 0 = Serial output data changes on transition from Idle clock state to active clock state
	SPI2CON1bits.MODE16 = 0;	// 0 = Communication is byte-wide (8 bits)
								// 1 = Communication is word-wide (16 bits)
	SPI2STATbits.SPIEN = 1;		// 1 = Enables module and configures SCKx, SDOx, SDIx and SSx as serial port pins
								// 0 = Disables module
	SPI2STATbits.SPIROV = 0;	//   
									
	SD_CS = 1;

	while (!FSInit());

*/
///////////////////////////////////////////////////////////////////////////////////////////////////
//////////////////  USART2 					   ////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////////////////////////

	//  USART1 (  )	
	PIN_USART2_TX_TRIS = 0;		//   TX USART1
	PIN_USART2_TX_RPO = 5;		//   5 (USART2.TX)   

	RPINR19bits.U2RXR = PIN_USART2_RX_NUM;
	PIN_USART2_RX_TRIS = 1;		// 



///////////////////////////////////////////////////////////////////////////////////////////////////
//////////////////  USART1 (   ) ////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////////////////////////
/*
	//  USART1 (  )	
	PIN_MASTER_TX_TRIS = 0;		//   TX USART1
	PIN_MASTER_TX_RPO = 3;		//   3 (USART1.TX)   

	RPINR18bits.U1RXR = PIN_MASTER_RX_NUM;
	PIN_MASTER_RX_TRIS = 1;		// 
	
	U1MODEbits.UEN0 = 0; 		//   rx/tx
	U1MODEbits.UEN1 = 0;
	U1MODEbits.BRGH = 0;		// 1 = BRG generates 4 clocks per bit period (4x baud clock, High-Speed mode)
								// 0 = BRG generates 16 clocks per bit period (16x baud clock, Standard mode)
	U1BRG = 25;					// (4000000/(16*9600))-1=25,04166666667 ( BRG=0)
	U1MODEbits.PDSEL0 = 0;
	U1MODEbits.PDSEL1 = 0;
	
	U1STAbits.UTXEN = 1;
	U1STAbits.UTXBRK = 0;		// 0 = Sync Break transmission disabled or completed
								// 1 = Send Sync Break on next transmission Start bit, 
								//		followed by twelve '0' bits, followed by Stop bit; cleared by hardware upon completion
		
	U1STAbits.UTXISEL1 = 1; // 1,0 -     ,     
	U1STAbits.UTXISEL0 = 0;
	IEC0bits.U1TXIE=1;		//       UART1

    IFS0bits.U1RXIF = 0;         
	U1STAbits.URXISEL = 0; 		// 3 = Interrupt is set on RSR transfer, making the receive buffer full (i.e., has 4 data characters)
								// 2 = Interrupt is set on RSR transfer, making the receive buffer 3/4 full (i.e., has 3 data characters)
								// 0,1 = Interrupt is set when any character is received and transferred from the RSR to the receive buffer.
	IEC0bits.U1RXIE=1;		//       UART1
	U1MODEbits.UARTEN = 1;
	while(U1STAbits.URXDA == 1)
    {
        char Temp;
        Temp = U1RXREG;
    }
		//  :
		// 	if (U1STAbits.OERR == 1) { U1STAbits.OERR = 0;	 //          
		// while(U1STAbits.URXDA == 1)	{ buff[i++] = U1RXREG; //    
		// 	while(U1STAbits.UTXBF); U1TXREG = data; //       
*/
///////////////////////////////////////////////////////////////////////////////////////////////////

/*
    // #########################################################################################################
	//   2    . (100)
	T2CONbits.T32 = 0; //     4   16 
	T4CONbits.T32 = 0;	
	T2CONbits.TCS = 0; // clock source - internal. Fosc/2 = 4   
	T2CONbits.TCKPS = 0; // prescaler 1:1    4
	PR2 = 40000; //   .     100
	IEC0bits.T2IE = 1; //    
	T2CONbits.TON = 1;

    // #########################################################################################################
*/
}
