// ****************************   ************************************
// ****************          *********
//  :
//		  LAT   _OUT
//		  TRIS   _TRIS
//		  CNPU   _PU
//		  RPOR   _RPO
//		  RPx    _NUM
// ***********************************************************************************

// pin2 RA0  LED ( )
#define PIN_LED_IN PORTAbits.RA0
#define PIN_LED_OUT LATAbits.LATA0
#define PIN_LED_TRIS TRISAbits.TRISA0

//////////////////////////////////////////////////////////////////////////////////////
//////////////////////   USART1 						     /////////////////
//////////////////////////////////////////////////////////////////////////////////////

// pin4 RB0 MASTER_TX
#define PIN_MASTER_TX_IN PORTBbits.RB0
#define PIN_MASTER_TX_TRIS TRISBbits.TRISB0
#define PIN_MASTER_TX_OUT LATBbits.LATB0
#define PIN_MASTER_TX_RPO RPOR0bits.RP0R	//        
#define PIN_MASTER_TX_NUM 0					//  RP,        RPINRxx

// pin5 RB1 MASTER_RX
#define PIN_MASTER_RX_IN PORTBbits.RB1
#define PIN_MASTER_RX_TRIS TRISBbits.TRISB1
#define PIN_MASTER_RX_OUT LATBbits.LATB1
#define PIN_MASTER_RX_RPO RPOR0bits.RP1R	//        
#define PIN_MASTER_RX_NUM 1					//  RP,        RPINRxx

//////////////////////////////////////////////////////////////////////////////////////
//////////////////////   USART2                            /////////////////
//////////////////////////////////////////////////////////////////////////////////////

// pin6 RB2 USART2_TX
#define PIN_USART2_TX_IN PORTBbits.RB2
#define PIN_USART2_TX_TRIS TRISBbits.TRISB2
#define PIN_USART2_TX_OUT LATBbits.LATB2
#define PIN_USART2_TX_RPO RPOR1bits.RP2R	//        
#define PIN_USART2_TX_NUM 2					//  RP,        RPINRxx

// pin7 RB3 USART2_RX
#define PIN_USART2_RX_IN PORTBbits.RB3
#define PIN_USART2_RX_TRIS TRISBbits.TRISB3
#define PIN_USART2_RX_OUT LATBbits.LATB3
#define PIN_USART2_RX_RPO RPOR1bits.RP3R	//        
#define PIN_USART2_RX_NUM 3					//  RP,        RPINRxx


//////////////////////////////////////////////////////////////////////////////////////
////////////////////////    Ethernet  //////////////////////
//////////////////////////////////////////////////////////////////////////////////////

// pin15 RB6 ENC_RESET ( ENC28J60)
#define PIN_ENC_RESET_OUT LATBbits.LATB6			
#define PIN_ENC_RESET_TRIS TRISBbits.TRISB6

// pin16 RB7 ENC_CS
#define PIN_ENC_CS_OUT LATBbits.LATB7
#define PIN_ENC_CS_TRIS TRISBbits.TRISB7

// pin17 RB8 ENC_SCK
#define PIN_ENC_SCK_IN PORTBbits.RB8
#define PIN_ENC_SCK_TRIS TRISBbits.TRISB8
#define PIN_ENC_SCK_RPO RPOR4bits.RP8R	//        
#define PIN_ENC_SCK_NUM 8				//  RP,        RPINRxx
//#define PIN_PAPER_PU CNPU1bits.CN8PUE	!!!!      

// pin18 RB9 ENC_SI (   ENC, SI-)
#define PIN_ENC_SI_OUT LATBbits.LATB9
#define PIN_ENC_SI_TRIS TRISBbits.TRISB9
#define PIN_ENC_SI_RPO RPOR4bits.RP9R	//        
#define PIN_ENC_SI_NUM 9				//  RP,        RPINRxx

// pin21 RB10 ENC_SO
#define PIN_ENC_SO_OUT LATBbits.LATB10		
#define PIN_ENC_SO_TRIS TRISBbits.TRISB10
#define PIN_ENC_SO_RPO RPOR5bits.RP10R	//        
#define PIN_ENC_SO_NUM 10				//  RP,        RPINRxx

// pin22 RB11 ENC_INT
#define PIN_ENC_INT_OUT LATBbits.LATB11		
#define PIN_ENC_INT_TRIS TRISBbits.TRISB11
#define PIN_ENC_INT_RPO RPOR5bits.RP11R	//        


//////////////////////////////////////////////////////////////////////////////////////
////////////////////////    SD-CARD   //////////////////////
//////////////////////////////////////////////////////////////////////////////////////

// pin23 RB12 SD_DO (   )
#define PIN_SD_DO_OUT LATBbits.LATB12		
#define PIN_SD_DO_TRIS TRISBbits.TRISB12
#define PIN_SD_DO_RPO RPOR6bits.RP12R	//        
#define PIN_SD_DO_NUM 12				//  RP,        RPINRxx

// pin24 RB13 CLK
#define PIN_SD_CLK_IN PORTBbits.RB13
#define PIN_SD_CLK_TRIS TRISBbits.TRISB13
#define PIN_SD_CLK_PU CNPU1bits.CN13PUE	// 
#define PIN_SD_CLK_RPO RPOR6bits.RP13R	//        
#define PIN_SD_CLK_NUM 13				//  RP,        RPINRxx

// pin25 RB14 SD_DI (   )
#define PIN_SD_DI_OUT LATBbits.LATB14		
#define PIN_SD_DI_TRIS TRISBbits.TRISB14
#define PIN_SD_DI_RPO RPOR7bits.RP14R	//        
#define PIN_SD_DI_NUM 14				//  RP,        RPINRxx

// pin26 RB15 SD_CS
#define PIN_SD_CS_OUT LATBbits.LATB15
#define PIN_SD_CS_TRIS TRISBbits.TRISB15
#define PIN_SD_CS_RPO RPOR7bits.RP15R	//        
#define PIN_SD_CS_NUM 15				//  RP,        RPINRxx




//////////////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////////////
// 								 

// pin3 RA1  LED
/*#define PIN_LED_IN PORTAbits.RA1
#define PIN_LED_OUT LATAbits.LATA1
#define PIN_LED_TRIS TRISAbits.TRISA1*/
/*

// pin6 RB2  SDO
//#define PIN_SDO PORTBbits.RB2
//#define PIN_SDO_TRIS TRISBbits.TRISB2
//#define PIN_SDO_PU CNPU1bits.CN2PUE		 // 
//#define PIN_SDO_RP RPOR1bits.RP2R

// pin7 RB3  SDI
#define PIN_SDI_IN PORTBbits.RB3
#define PIN_SDI_TRIS TRISBbits.TRISB3
#define PIN_SDI_PU CNPU1bits.CN3PUE		 // 
#define PIN_SDI_NUM 3

// pin12 RA4 " "
#define PIN_SH_OPENED_IN PORTAbits.RA4
#define PIN_SH_OPENED_OUT LATAbits.LATA4
#define PIN_SH_OPENED_TRIS TRISAbits.TRISA4

// pin11 RB4 " "
#define PIN_SH_CLOSED_IN PORTBbits.RB4
#define PIN_SH_CLOSED_OUT LATBbits.LATB4
#define PIN_SH_CLOSED_TRIS TRISBbits.TRISB4

*/
/*   PGD1  PGC1
// pin4 RB0 RX  
#define PIN_MASTER_RX_OUT LATBbits.LATB0
#define PIN_MASTER_RX_TRIS TRISBbits.TRISB0
#define PIN_MASTER_RX_RPO RPOR0bits.RP0R	//        
#define PIN_MASTER_RX_NUM 0					//  RP,        RPINRxx

// pin5 RB1 TX  
#define PIN_MASTER_TX_OUT LATBbits.LATB1
#define PIN_MASTER_TX_TRIS TRISBbits.TRISB1
#define PIN_MASTER_TX_RPO RPOR0bits.RP1R	//        
*/
